<template>
  <Form ref="userData"
        :model="userData"
        :rules="userDataRules"
        inline>
    <FormItem prop="user">
      <Input type="text"
             v-model="userData.username"
             placeholder="Username">
      <Icon type="ios-person-outline"
            slot="prepend"></Icon>
      </Input>
    </FormItem>
    <FormItem prop="password">
      <Input type="password"
             v-model="userData.password"
             placeholder="Password">
      </Input>
    </FormItem>
    <FormItem>
      <Button type="primary"
              @click="handleSubmit('userData')">Submit</Button>
    </FormItem>
  </Form>
</template>

<script>
import axios from "axios"

export default {
  name: "CreateUser",
  data: () => ({
    isLoading: true,
    isSending: false,
    userData: {
      username: "",
      password: ""
    },
    userDataRules: {
      username: [
        {
          required: true,
          message: "Please fill in the username",
          trigger: "blur"
        }
      ],
      password: [
        {
          required: true,
          message: "Please fill in the password.",
          trigger: "blur"
        },
        {
          type: "string",
          min: 8,
          message: "At least 8 characters",
          trigger: "blur"
        }
      ]
    }
  }),
  methods: {
    handleSubmit(name) {
      this.$refs[name].validate(valid => {
        if (valid) {
          this.createAccount()
        } else {
          console.error("not ok")
        }
      })
    },
    clearForm() {
      this.userData.username = null
      this.userData.password = null
    },
    createAccount() {
      if (!this.isSending) {
        this.isSending = true
        this.$Spin.show()
        axios({
          method: "POST",
          url: this.$baseApiUrl + "/administration/user",
          data: this.userData,
          headers: { "content-type": "application/json" }
        }).then(
          result => {
            console.log(result)
            this.isSending = false
            this.clearForm()
            this.$Spin.hide()
          },
          error => {
            console.error(error)
            this.isSending = false
            this.clearForm()
            this.$Spin.hide()
          }
        )
      }
    }
  }
}
</script>
